/* VMSystemProperties.java -- Allow the VM to set System properties.
   Copyright (C) 2004 Free Software Foundation

This file is part of GNU Classpath.

GNU Classpath is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GNU Classpath is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU Classpath; see the file COPYING.  If not, write to the
Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
02110-1301 USA.

Linking this library statically or dynamically with other modules is
making a combined work based on this library.  Thus, the terms and
conditions of the GNU General Public License cover the whole
combination.

As a special exception, the copyright holders of this library give you
permission to link this library with independent modules to produce an
executable, regardless of the license terms of these independent
modules, and to copy and distribute the resulting executable under
terms of your choice, provided that you also meet, for each linked
independent module, the terms and conditions of the license of that
module.  An independent module is a module which is not derived from
or based on this library.  If you modify this library, you may extend
this exception to your version of the library, but you are not
obligated to do so.  If you do not wish to do so, delete this
exception statement from your version. */

package gnu.classpath;

import java.io.File;
import java.util.Properties;

class VMSystemProperties
{
	/**
	 * JAVA_HOMEを返す
	 */
	public static native String getJavaHome();
	
	/**
	 * テンポラリフォルダを返す
	 */
	public static native String getTempDir();
	
	/**
	 * Mysaifu JVMのバージョンを返す
	 */
	public static native String getJVMVersion();
	
	/**
	 * ユーザ名を返す
	 */
	public static native String getUserName();

	/**
	 * ユーザディレクトリを返す
	 */
	public static native String getUserHome();
	
	/**
	 * OSの名前を返す
	 */
	public static native String getOSName();
	
	/**
	 * OSのアーキテクチャを返す
	 */
	public static native String getOSArch();
	
	/**
	 * OSのバージョンを返す
	 */
	public static native String getOSVersion();
	
	/**
	 * デフォルトのエンコーディングを返す
	 */
	public static native String getDefaultEncoding();
	
	/**
	 * カレントディレクトリを返す。
	 *
	 * @return	カレントディレクトリ
	 * @since	Mysaifu JVM 0.25
	 */
	public static native String getCurrentDirectory();
	
    /**
     * Get the system properties. This is done here, instead of in System,
     * because of the bootstrap sequence. Note that the native code should
     * not try to use the Java I/O classes yet, as they rely on the properties
     * already existing. The only safe method to use to insert these default
     * system properties is {@link Properties#setProperty(String, String)}.
     *
     * <p>These properties MUST include:
     * <dl>
     * <dt>java.version         <dd>Java version number
     * <dt>java.vendor          <dd>Java vendor specific string
     * <dt>java.vendor.url      <dd>Java vendor URL
     * <dt>java.home            <dd>Java installation directory
     * <dt>java.vm.specification.version <dd>VM Spec version
     * <dt>java.vm.specification.vendor  <dd>VM Spec vendor
     * <dt>java.vm.specification.name    <dd>VM Spec name
     * <dt>java.vm.version      <dd>VM implementation version
     * <dt>java.vm.vendor       <dd>VM implementation vendor
     * <dt>java.vm.name         <dd>VM implementation name
     * <dt>java.specification.version    <dd>Java Runtime Environment version
     * <dt>java.specification.vendor     <dd>Java Runtime Environment vendor
     * <dt>java.specification.name       <dd>Java Runtime Environment name
     * <dt>java.class.version   <dd>Java class version number
     * <dt>java.class.path      <dd>Java classpath
     * <dt>java.library.path    <dd>Path for finding Java libraries
     * <dt>java.io.tmpdir       <dd>Default temp file path
     * <dt>java.compiler        <dd>Name of JIT to use
     * <dt>java.ext.dirs        <dd>Java extension path
     * <dt>os.name              <dd>Operating System Name
     * <dt>os.arch              <dd>Operating System Architecture
     * <dt>os.version           <dd>Operating System Version
     * <dt>file.separator       <dd>File separator ("/" on Unix)
     * <dt>path.separator       <dd>Path separator (":" on Unix)
     * <dt>line.separator       <dd>Line separator ("\n" on Unix)
     * <dt>user.name            <dd>User account name
     * <dt>user.home            <dd>User home directory
     * <dt>user.dir             <dd>User's current working directory
     * <dt>gnu.cpu.endian       <dd>"big" or "little"
     * </dl>
     *
     * @param p the Properties object to insert the system properties into
     */
    static void preInit(Properties properties) {
		// JAVA_HOMEを取得
		String javaHome = getJavaHome();
		
		properties.put("java.version", "1.6");
		properties.put("java.vendor",  "Mysaifu");
		properties.put("java.vendor.url", "http://www2s.biglobe.ne.jp/~dat/java/project/jvm/index_en.html");
		properties.put("java.home", javaHome);

		properties.put("java.vm.specification.version", "1.6");
		properties.put("java.vm.specification.vendor", "");
		properties.put("java.vm.specification.name", "");
		properties.put("java.vm.version", getJVMVersion());
		properties.put("java.vm.vendor", "Mysaifu");
		properties.put("java.vm.name", "Mysaifu JVM");

		properties.put("java.specification.version", "1.6");
		properties.put("java.specification.vendor", "");
		properties.put("java.specification.name", "GNU Classpath");
		properties.put("java.class.version", "50.0");
		
		// java.library.path は java.home を基準にする
		properties.put("java.library.path", javaHome + "\\jre\\bin");
		
		// テンポラリファイルを作成するディレクトリ
		properties.put("java.io.tmpdir", getTempDir());
		
		// JITコンパイラ
		properties.put("java.compiler", "");
		
		// Java extention path
		properties.put("java.ext.dirs", javaHome + "\\jre\\lib\\ext");
		
		// OS関連情報
		properties.put("os.name", getOSName());
		properties.put("os.arch", getOSArch());
		properties.put("os.version", getOSVersion());
		
		// ファイル関連定数
		properties.put("file.separator", "\\");
		properties.put("path.separator", ";");
		properties.put("line.separator", "\r\n");
		
		// ユーザ関連情報
		properties.put("user.name", getUserName());
		properties.put("user.home", getUserHome());
		properties.put("user.dir", getCurrentDirectory());

		// エンディアン(GNU Classpathが参照している）
		properties.put("gnu.cpu.endian", "little");
		
		// エンコーディング
		properties.put("file.encoding", getDefaultEncoding());
		
		// libiconvを使用する
		properties.put("gnu.classpath.nio.charset.provider.iconv", "true");
		
		// java.util.Currencyのインスタンスを生成するために必要
		properties.put("user.region", "US");
		
		// VMClassLoaderのリソース読み込みパス
		properties.put("com.mysaifu.jvm.resource.path", javaHome + "\\jre\\lib\\resource.jar");
		
	}
	
   /**
     * Here you get a chance to overwrite some of the properties set by
     * the common SystemProperties code. For example, it might be
     * a good idea to process the properties specified on the command
     * line here.
     */
    static native void postInit(Properties properties);
    
}
